/* ===== creating dynamic envelopes for additive synthesis ====================================== */

/* ----- establishing global parameters --------------------------------------------------------- */

// some objects attributs of createPatch jS object

autowatch 	= 1;	
inlets 		= 1;
outlets 	= 1;

// some global variables to connect cables and reference the patch

var p2 				= this.patcher;
var partEnvTrig 	= p2.getnamed("partEnvTrig");
var partEnvHarm		= p2.getnamed("partEnvHarm");
var partEnvDura  	= p2.getnamed("partEnvDura");
var partEnvReset	= p2.getnamed("partEnvReset");


// arrays and counters

var objectcount = 0;
var envelopes	= new Array();

/* ----- function to connect dynamic objects ---------------------------------------------------- */

function connectEnvelopes(){

	post("trying to connect envelopes\n");
	
	var i;
	
	for(i = 0; i < objectcount; i++){	
		
		p2.connect(partEnvHarm,0,envelopes[i],0);
		p2.connect(partEnvDura,0,envelopes[i],1);
		p2.connect(partEnvTrig,0,envelopes[i],2);
		p2.connect(partEnvReset,0,envelopes[i],3);
		
	}
	
	outlet(0,"bang");
	
} 

/* ----- generate envelope ------------------------------------------------------------------------ */

function generateDynamicEnvelope(x){
	
	for(i = 0; i < objectcount; i++){
	
		p2.remove(envelopes[i]);	
	
	}
	
	objectcount = Math.abs(x);

	partials = new Array();
	
	if(objectcount > 0){
		
		for(i = 0; i < x; i++){

			var left = 730;
			var top = (30 * i) + 20;
			var count	= i + 1;
			
			// assigning object and a unique count id
			envelopes[i] = p2.newdefault(left,top,"partialEnvelope", count);
			
			// uncorporation unique count id as a scripting name	
			envelopes[i].varname = "partialEnvelope-" + count;
	
		}
		
		//connectEnvelopes();
		outlet(0,"bang");
		
	}
	
}