/* ===== creating dynamic partials for additive synthesis ======================================= */

/* ----- establishing global parameters --------------------------------------------------------- */

// some objects attributs of createPatch jS object

autowatch 	= 1;	
inlets 		= 1;
outlets 	= 1;

// some global variables to connect cables and reference the patch

var p 				= this.patcher;
var partialBanger 	= p.getnamed("partialBanger");
var partialOut 	    = p.getnamed("partialOut");
var partialCounter  = p.getnamed("partialCounter");

// arrays and counters

var objectcount = 0;
var partials	= new Array();

/* ----- function to connect dynamic objects ---------------------------------------------------- */

function connectPartials(){

	var i;
	
	for(i = 0; i < objectcount; i++){	
		
		p.connect(partialBanger,0,partials[i],0);
		p.connect(partialBanger,1,partials[i],1);
		p.connect(partials[i],0,partialOut,0);
		p.connect(partials[i],1,partialCounter,0);
		
	}
	
	outlet(0,"bang");
	
} 

/* ----- generate partial ------------------------------------------------------------------------ */

function generateDynamicPartial(x){


	for(i = 0; i < objectcount; i++){
	
		p.remove(partials[i]);	
	
	}
	
	objectcount = Math.abs(x);

	partials = new Array();
	
	if(objectcount > 0){
		
		for(i = 0; i < x; i++){

			var left = 20;
			var top = (30 * i) + 80;
			
			var count	= i + 1;
			
			// frequency and harmonicity in relation to # of OSCs
			// var freq 	= (i == 0) ? f : f * ((i * h) + h);
			var scale 	= 1/objectcount; 
			
			// randomly change timbre
			// var timbre 	= (o == 1 && t) ? Math.random() : 1; 
			
			// assigning object and a unique count id
			partials[i] = p.newdefault(left,top,"additivePartial~", count, scale);
			
			// uncorporation unique count id as a scripting name	
			partials[i].varname = "additivePartial-" + count;
	
		}
	
		connectPartials();
		
	}
	
}